#!/bin/sh
# wget http://search.cpan.org/CPAN/authors/id/N/NW/NWCLARK/perl-5.8.8.tar.gz

set -x
## M$ sucks
unset LIB
unset INCLUDE
export CYGWIN=server

## run the build with ntsec on if possible...
pkg=perl
ver=5.8.8
major=5.8
release=-4
dir=`pwd`
shortver=`echo ${ver}${release} | sed 's/-.*//'`
buildperl=buildperl

## check prereqs
set +x
for i in ${pkg}-${ver}.tar.gz ${pkg}-${ver}-ext-Win32CORE.tar.bz2 Policy.sh; 
    do test -e $i || (echo preq $i not found && exit); 
done
exts="Win32API-File-0.1001 \
	Pod-Escapes-1.04 Pod-Simple-3.05 Test-Pod-1.26 Devel-Symdump-2.07 Pod-Coverage-0.18 Test-Pod-Coverage-1.08 \
	IO-Compress-Base-2.005 \
	Compress-Raw-Zlib-2.005 IO-Compress-Zlib-2.005 Compress-Zlib-2.005 \
	Compress-Raw-Bzip2-2.005 IO-Compress-Bzip2-2.005 Compress-Bzip2-2.09 \
        IO-Zlib-1.05	\
        IO-String-1.08	\
        MD5-2.03 \
        Archive-Tar-1.32 Archive-Zip-1.20 \
	Math-BigInt-FastCalc-0.15 \
	Term-ReadLine-Perl-1.0302 Term-ReadLine-Gnu-1.16 TermReadKey-2.30 \
        XML-NamespaceSupport-1.09 XML-SAX-0.15 XML-LibXML-Common-0.13 XML-LibXML-1.63 \
	XML-Parser-2.34	\
	Proc-ProcessTable-0.41 \
	File-Temp-0.18 YAML-0.62 \
	Config-Tiny-2.10 File-Copy-Recursive-0.33 IPC-Run3-0.037 Probe-Perl-0.01 \
    	Tee-0.13 IO-CaptureOutput-1.03 File-pushd-0.99 File-HomeDir-0.65 \
	Digest-SHA-5.45 \
	Module-Signature-0.55 \
        URI-1.35 HTML-Tagset-3.10 HTML-Parser-3.56 libwww-perl-5.805 \
	CPAN-1.9102 \
	Test-Reporter-1.27 CPAN-Reporter-0.44 \
	Net-Telnet-3.03	\
	Module-ScanDeps-0.75 PAR-Dist-0.23 \
	ExtUtils-CBuilder-0.19 ExtUtils-ParseXS-2.18 Regexp-Common-2.120 \
	  version-0.7203 podlators-2.0.5 Pod-Readme-0.09 Module-Build-0.2808 \
	B-Generate-1.09 PadWalker-1.5 Alias-2.32"
# PAR not because of /usr/bin/pp
# Algorithm-Diff-1.1902 Text-Diff-0.35 not needed because we removed usr/bin/ptardiff
for i in $exts; do test -e $i.tar.gz || echo preq $i.tar.gz not found; done
for i in $exts; do test -e $i.tar.gz || exit; done
set -x

exit

## checkout builddir
rm -rf ${dir}/${buildperl} 2> /dev/null
sleep 2
mkdir -p -m 777 ${dir}/${buildperl}

## unpack
rm -rf ${pkg}-${ver} 2> /dev/null
sleep 2
tar xfz ${pkg}-${ver}.tar.gz
tar xjvf ${pkg}-${ver}-ext-Win32CORE.tar.bz2
mkdir -p /usr/share/doc/${pkg}-${ver}
/bin/install -m 644 ${pkg}-${ver}/Artistic ${pkg}-${ver}/Copying ${pkg}-${ver}/Changes* ${pkg}-${ver}/README /usr/share/doc/${pkg}-${ver}

# pl-hints.cygwin.sh.patch must be before pl-win32CORE.patch
for p in pl-*.patch; do
  (cd ${pkg}-${ver}; patch -p1 -bu <../$p; cd -)
done
# patch bug: chmod 0000 => 0444
cd ${pkg_ver}; find . -name \*.orig -exec chmod 0444 \{\} \;

## configure perl
cd ${dir}/${buildperl}
set +x

cp ${dir}/Policy.sh ${dir}/${buildperl}

sh ${dir}/${pkg}-${ver}/Configure -de	\
		-Dmksymlinks	\
		-Duse64bitint	\
		-Dusethreads	\
		-Uusemymalloc   \
		-Doptimize='-O3'	\
		-Dman3ext='3pm'	\
		-Dusesitecustomize \
		-Dusedevel \
		2>&1 | tee ${dir}/log.configure

# Implied by usethreads
#		-Dusemultiplicity	\
#		-Uusemymalloc	\

## build perl
make -j1 2>&1 | tee ${dir}/log.make

#cp /usr/bin/cygcrypt-0.dll .

## make the tests
export PERLIO=perlio
make -j1 test 2>&1 | tee ${dir}/log.test
grep '\.\.skip' ${dir}/log.test > ${dir}/log.test.skipped
egrep -i '(\.#|\..FAIL| Fail)' ${dir}/log.test > ${dir}/log.test.failed
if test -s ${dir}/log.test.failed; then
  (cd t; ./perl harness) 2>&1 | tee ${dir}/log.harness
fi

#rm -f cygcrypt-0.dll

## install
make -j1 install-strip DESTDIR="" 2>&1 | tee ${dir}/log.install

cd ${dir}
rm ${dir}/log.make_vendor ${dir}/log.install_vendor 2> /dev/null
# introduce some old and new vendor_perl libs
for i in $exts;
do rm -rf ${i}; \
  (tar xzf ${i}.tar.gz 2>&1 | tee -a ${dir}/log.make_vendor &&	\
    (cd ${i} &&	\
    if test -f ../$i.patch; then \
	patch -b -p1 < ../$i.patch 2>&1 | tee -a ${dir}/log.make_vendor; \
	find -name \*.orig -exec chmod 0444 \{\} \; ; \
    fi &&  \
    ${dir}/${buildperl}/perl Makefile.PL | tee -a ${dir}/log.make_vendor && \
    make -j1 2>&1 | tee -a ${dir}/log.make_vendor &&	\
    make -j1 install_vendor UNINST=1 2>&1 | tee -a ${dir}/log.make_vendor)); \
done
#Compress::Raw::Zlib requires an invisible y here


